unit Service_U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs,syncobjs;

type
  TService_F = class(TService)
    procedure ServiceCreate(Sender: TObject);
    procedure ServiceDestroy(Sender: TObject);
    procedure ServiceExecute(Sender: TService);
    procedure ServiceStart(Sender: TService; var Started: Boolean);
    procedure ServiceStop(Sender: TService; var Stopped: Boolean);
  private
    IsRuning:Boolean;
    FLock:TCriticalSection;
    { Private declarations }
  public
    function GetServiceController: TServiceController; override;
    function Runing:Boolean;
    { Public declarations }
  end;

var
  Service_F: TService_F;

implementation

uses Unit1, Unit2, Unit3;

{$R *.DFM}

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  Service_F.Controller(CtrlCode);
end;

function TService_F.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

function TService_F.Runing: Boolean;
begin
  FLock.Enter;
  Result:=IsRuning;
  FLock.Leave;
end;

procedure TService_F.ServiceCreate(Sender: TObject);
begin
  FLock:=TCriticalSection.Create;
end;

procedure TService_F.ServiceDestroy(Sender: TObject);
begin
  FLock.Free;
end;

procedure TService_F.ServiceExecute(Sender: TService);
begin
  while Runing do
  begin
    Sleep(1);
    Sender.ServiceThread.ProcessRequests(false);
  end;
end;

procedure TService_F.ServiceStart(Sender: TService; var Started: Boolean);
begin
  IsRuning:=True;
  Application.Title:='VNC Server Component Demo';
  Form1:=TForm1.Create(Application);
  form2:=TForm2.Create(Application);
  Form3:=TForm3.create(Application);
  Form1.n1.Visible:=false;
  Form1.Exit1.Visible:=false;
  Form1.VNCServer1.UseHookDLL:=false;
  Form1.Show;
  Form1.chkStart.Checked:=true;
  Started := True;
end;

procedure TService_F.ServiceStop(Sender: TService; var Stopped: Boolean);
begin
  FLock.Enter;
  IsRuning:=False;
  FLock.Leave;
  Form1.mvCanClose:=true;
  Form1.Close;
  FreeAndNil(Form1);
  Stopped := True;
end;

end.
