unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, VNCServer, StdCtrls, ExtCtrls, XPMan, Buttons, Menus,ShellAPI,inifiles;

const
  KEY_IE            = 'SOFTWARE\Microsoft\Internet Explorer';

type
  TForm1 = class(TForm)
    rgDisconnect: TRadioGroup;
    XPManifest1: TXPManifest;
    gbIncoming: TGroupBox;
    chkDQW: TCheckBox;
    Label1: TLabel;
    edtTimeOut: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    rbRefuse: TRadioButton;
    rbAccept: TRadioButton;
    gbKBMouse: TGroupBox;
    chkdvi: TCheckBox;
    chkdli: TCheckBox;
    rgMultiViewer: TRadioGroup;
    gbAuth: TGroupBox;
    Label4: TLabel;
    edtPwd: TEdit;
    chkMslogon: TCheckBox;
    gbConnections: TGroupBox;
    Label5: TLabel;
    edtPort: TEdit;
    GroupBox1: TGroupBox;
    chkRWV: TCheckBox;
    chkEBM: TCheckBox;
    chkEAM: TCheckBox;
    chkCAB: TCheckBox;
    GroupBox2: TGroupBox;
    chkFileTransfer: TCheckBox;
    chkStart: TCheckBox;
    VNCServer1: TVNCServer;
    GroupBox3: TGroupBox;
    chkDSM: TCheckBox;
    cbDSM: TComboBox;
    PopupMenu3: TPopupMenu;
    KillClient1: TMenuItem;
    ChatWithClient1: TMenuItem;
    chkhttp: TCheckBox;
    edtHttp: TEdit;
    GroupBox5: TGroupBox;
    ListBox1: TListBox;
    PopupMenu1: TPopupMenu;
    Restore1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    chkLookback: TCheckBox;
    Button1: TButton;
    GroupBox4: TGroupBox;
    chkFullScreen: TCheckBox;
    Label6: TLabel;
    edtServerScale: TEdit;
    procedure chkStartClick(Sender: TObject);
    procedure chkFileTransferClick(Sender: TObject);
    procedure edtPwdChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure rgDisconnectClick(Sender: TObject);
    procedure chkdviClick(Sender: TObject);
    procedure chkdliClick(Sender: TObject);
    procedure chkDQWClick(Sender: TObject);
    procedure VNCServer1IncomingConnection(Sender: TObject; IP: String;
      var Accept: Boolean; var cbMsg: String);
    procedure rgMultiViewerClick(Sender: TObject);
    procedure chkRWVClick(Sender: TObject);
    procedure chkCABClick(Sender: TObject);
    procedure chkDSMClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkEBMClick(Sender: TObject);
    procedure chkEAMClick(Sender: TObject);
    procedure VNCServer1ClientChatEvent(Sender: TObject;
      Client: TVNCClientConnection; msg: String; MsgID: Integer);
    procedure VNCServer1ClientConnected(Sender: TObject;
      Client: TVNCClientConnection; msg: String; MsgID: Integer);
    procedure VNCServer1ClientDisconnected(Sender: TObject;
      Client: TVNCClientConnection; msg: String; MsgID: Integer);
    procedure ListBox1ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure KillClient1Click(Sender: TObject);
    procedure ChatWithClient1Click(Sender: TObject);
    procedure Restore1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure chkFullScreenClick(Sender: TObject);
    procedure chkMslogonClick(Sender: TObject);
  private
    { Private declarations }
    FIconData: TNotifyIconData;
    NT351: Boolean;
    FTaskMessage: DWord;
    procedure AddIcon;
    procedure SelfIcon(var Message: TMessage); message WM_USER+101;
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
    mvCanClose:Boolean;
    function GetChat(ID:Integer):TForm;
  end;

var
  Form1: TForm1;

implementation

uses Unit2, Chat_U, Unit3;

{$R *.dfm}

procedure TForm1.chkStartClick(Sender: TObject);
begin
  VNCServer1.Password:=edtPwd.Text;
  VNCServer1.FileTransfer:=chkFileTransfer.Checked;
  VNCServer1.Port:=StrToIntDef(edtPort.Text,5900);
  VNCServer1.ActionAftterClientDisconnect:=TDisconnectAction(rgDisconnect.ItemIndex);
  VNCServer1.DisableViewerInput:=chkdvi.Checked;
  VNCServer1.MultiViewerConnections:=TMultiViewerConnections(rgMultiViewer.ItemIndex);
  VNCServer1.RemoveWallPaperViewers:=chkRWV.Checked;
  VNCServer1.CaptureAlphaBlending:=chkCAB.Checked;
  VNCServer1.DSMPlugin:=chkDSM.Checked;
  VNCServer1.DSMPluginUsed:=ExtractFilePath(Application.ExeName)+cbDSM.Text;
  VNCServer1.EnableAlpahBlending:=chkEAM.Checked;
  VNCServer1.EnableBlankMonitor:=chkEBM.Checked;
  VNCServer1.EnableHttpConnect:=chkhttp.Checked;
  VNCServer1.HttpPort:=StrToIntDef(edtHttp.Text,5800);
  VNCServer1.RequireMSLogon:= chkMslogon.Checked;
  VNCServer1.ServerScale:=StrToIntDef(edtServerScale.Text,1);
  VNCServer1.PollFullScreen:=chkFullScreen.Checked;
  if chkStart.Checked then
  begin
    if not VNCServer1.Startup then
    begin
      chkStart.Checked:=false;
      Exit;
    end;
    Hide;
  end
  else
    VNCServer1.Shutdown;
  Button1.Enabled:=chkStart.Checked;
  edtPort.Enabled:=not chkStart.Checked;
  chkDSM.Enabled:=not chkStart.Checked;
  chkhttp.Enabled:=not chkStart.Checked;
  edtHttp.Enabled:=not chkStart.Checked;
  edtServerScale.Enabled:=not chkStart.Checked;
end;

procedure TForm1.chkFileTransferClick(Sender: TObject);
begin
  VNCServer1.FileTransfer:=chkFileTransfer.Checked;
end;

procedure TForm1.edtPwdChange(Sender: TObject);
begin
  VNCServer1.Password:=edtPwd.Text;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=mvCanClose;
  Hide;
end;

procedure TForm1.rgDisconnectClick(Sender: TObject);
begin
  VNCServer1.ActionAftterClientDisconnect:=TDisconnectAction(rgDisconnect.ItemIndex);
end;

procedure TForm1.chkdviClick(Sender: TObject);
begin
  VNCServer1.DisableViewerInput:=chkdvi.Checked;
end;

procedure TForm1.chkdliClick(Sender: TObject);
begin
  VNCServer1.DisableLocalInput:=chkdli.Checked;
end;

procedure TForm1.chkDQWClick(Sender: TObject);
begin
  EdtTimeout.Enabled:=chkDQW.Checked;
  label1.Enabled:=chkDQW.Checked;
  Label2.Enabled:=chkDQW.Checked;
  Label3.Enabled:=chkDQW.Checked;
  rbRefuse.Enabled:=chkDQW.Checked;
  rbAccept.Enabled:=chkDQW.Checked;
end;

procedure TForm1.VNCServer1IncomingConnection(Sender: TObject; IP: String;
  var Accept: Boolean; var cbMsg: String);
begin
  if (not chkLookback.Checked) and (ip='127.0.0.1') then
  begin
    cbMsg:='Can not allow lookback connections';
    Accept:=false;
    Exit;
  end;
  if not chkDQW.Checked then
    Exit;
  cbMsg:='test reject msg';
  Form2:=TForm2.Create(nil);
  Form2.Caption:=IP+' Incoming do you ?';
  Form2.FMax:=StrToIntDef(edtTimeOut.Text,10);
  Form2.rbRefuse.Checked:=rbRefuse.Checked;
  if Form2.ShowModal<>mrOK then
  begin
    Accept:=false
  end
  else
  begin
    Accept:=Form2.rbAccept.Checked;
    Form2.Free;
  end;
end;

procedure TForm1.rgMultiViewerClick(Sender: TObject);
begin
  VNCServer1.MultiViewerConnections:=TMultiViewerConnections(rgMultiViewer.ItemIndex);
end;

procedure TForm1.chkRWVClick(Sender: TObject);
begin
  VNCServer1.RemoveWallPaperViewers:=chkRWV.Checked;
end;

procedure TForm1.chkCABClick(Sender: TObject);
begin
  VNCServer1.CaptureAlphaBlending:=chkCAB.Checked;
end;

procedure TForm1.chkDSMClick(Sender: TObject);
begin
  cbDSM.Enabled:=chkDSM.Checked;
  if chkDSM.Checked then
    if cbDSM.Items.Count>0 then
      cbDSM.ItemIndex:=0;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  s:TSearchRec;
  Ini:TIniFile;
  function IE4Installed: Boolean;
  var
    RegKey: HKEY;
  begin
    Result := False;
    if RegOpenKey(HKEY_LOCAL_MACHINE, KEY_IE, RegKey) = ERROR_SUCCESS then
    try
      Result := RegQueryValueEx(RegKey, 'Version', nil, nil, nil, nil) = ERROR_SUCCESS;
    finally
      RegCloseKey(RegKey);
    end;
  end;
begin
//  Application.ShowMainForm:=false;
  NT351 := (Win32MajorVersion <= 3) and (Win32Platform = VER_PLATFORM_WIN32_NT);
  if IE4Installed then
    FTaskMessage := RegisterWindowMessage('TaskbarCreated');
  AddIcon;
  if FindFirst(ExtractFilePath(Application.ExeName)+'*.dsm',faAnyFile,s)=0 then
    repeat
      cbDSM.Items.Add(s.Name);
    until FindNext(s)<>0;
  FindClose(s);
  Ini:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'option.ini');
  edtPwd.Text:=ini.ReadString('option','Password','');
  chkFileTransfer.Checked:=ini.ReadBool('option','FileTransfer',true);
  edtPort.Text:=ini.ReadString('option','Port','5900');
  rgDisconnect.ItemIndex:=ini.ReadInteger('option','ActionAftterClientDisconnect',0);
  chkdvi.Checked:=ini.ReadBool('option','DisableViewerInput',false);
  rgMultiViewer.ItemIndex:=ini.ReadInteger('option','MultiViewerConnections',0);
  chkRWV.Checked:=ini.ReadBool('option','RemoveWallPaperViewers',false);
  chkCAB.Checked:=ini.ReadBool('option','CaptureAlphaBlending',false);
  chkDSM.Checked:=ini.ReadBool('option','DSMPlugin',false);
  cbDSM.Text:=ini.ReadString('option','DSMPluginUsed','');
  chkEAM.Checked:=ini.ReadBool('option','EnableAlpahBlending',false);
  chkEBM.Checked:=ini.ReadBool('option','EnableBlankMonitor',false);
  chkhttp.Checked:=ini.ReadBool('option','EnableHttpConnect',true);
  edtHttp.Text:=ini.ReadString('option','HttpPort','5800');
  chkMslogon.Checked:=ini.ReadBool('option','RequireMSLogon',false);
  edtServerScale.Text:=ini.ReadString('option','ServerScale','1');
  chkFullScreen.Checked:=ini.ReadBool('option','PollFullScreen',false);
  ini.Free;
end;

procedure TForm1.chkEBMClick(Sender: TObject);
begin
  VNCServer1.EnableBlankMonitor:=chkEBM.Checked;
end;

procedure TForm1.chkEAMClick(Sender: TObject);
begin
  VNCServer1.EnableAlpahBlending:=chkEAM.Checked;
end;

procedure TForm1.VNCServer1ClientChatEvent(Sender: TObject;
  Client: TVNCClientConnection; msg: String; MsgID: Integer);
var
  lChat:TChat_F;
  OldStart:integer;  
begin
  case MsgID of    //
    CHAT_OPEN:
    begin
      lChat:=Tchat_F(GetChat(Client.ID));
      if lChat<>nil then
        lChat.Show;
    end;
    CHAT_CLOSE,CHAT_FINISHED:
    begin
      lChat:=Tchat_F(GetChat(Client.ID));
      if lChat<>nil then
        lChat.Close;
    end;
  else
    begin
      lChat:=Tchat_F(GetChat(Client.ID));
      if lChat<>nil then
      begin
        if not lChat.Visible then
          lChat.Show;
        with lChat do
        begin
          EdtMsg.SelStart:=99999999;
          OldStart:=EdtMsg.SelStart;
          EdtMsg.Lines.Text:=edtMsg.Lines.Text+'Remote:'+msg;
          EdtMsg.SelStart:=OldStart;
          EdtMsg.SelLength:=Length('Local:'+msg);
          EdtMsg.SelAttributes.Color:=clblue;
          EdtMsg.SelLength:=0;
          EdtMsg.SelStart:=99999999;
        end;    // with
      end;
    end;
  end;    // case
end;

procedure TForm1.VNCServer1ClientConnected(Sender: TObject;
  Client: TVNCClientConnection; msg: String; MsgID: Integer);
begin
  Chat_F:=TChat_F.Create(nil);
  Chat_F.Client:=Client;
  Chat_F.ID:=MsgID;
  ListBox1.Items.AddObject(IntToStr(MsgID)+':'+Client.RemoteIP,Chat_F);
end;

procedure TForm1.VNCServer1ClientDisconnected(Sender: TObject;
  Client: TVNCClientConnection; msg: String; MsgID: Integer);
var
  I: Integer;
  lChat:TChat_F;
begin
  for I := ListBox1.Items.Count-1 downto 0 do    // Iterate
    if TChat_F(ListBox1.Items.Objects[i]).ID=MsgID then
    begin
      lChat:=TChat_F(ListBox1.Items.Objects[i]);
      ListBox1.Items.Delete(i);
      lChat.Close;
      lChat.Free;
      break;
    end;    // for
end;

function TForm1.GetChat(ID: Integer): TForm;
var
  I: Integer;
begin
  result := nil;
  for I := 0 to Listbox1.Items.Count - 1 do    // Iterate
    if TChat_F(ListBox1.Items.Objects[i]).ID=ID then
    begin
      result := TChat_F(ListBox1.Items.Objects[i]);
      Break;
    end;    // for
end;

procedure TForm1.ListBox1ContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  if ListBox1.ItemIndex<0 then
    Handled:=true;
end;

procedure TForm1.KillClient1Click(Sender: TObject);
var
  lChat:TChat_F;
begin
  lChat:=TChat_F(ListBox1.Items.Objects[ListBox1.ItemIndex]);
  lChat.Client.Disconnect;
end;

procedure TForm1.ChatWithClient1Click(Sender: TObject);
var
  lChat:TChat_F;
begin
  lChat:=TChat_F(ListBox1.Items.Objects[ListBox1.ItemIndex]);
  lChat.Client.SendTextChatRequest(CHAT_OPEN);
end;

procedure TForm1.Restore1Click(Sender: TObject);
begin
  Show;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  mvCanClose:=true;
  Close;
end;

procedure TForm1.AddIcon;
begin
  if not NT351 then
  begin
    with FIconData do
    begin
      cbSize := SizeOf(FIconData);
      Wnd := Self.Handle;
      uID := $DEDB;
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
      hIcon := Forms.Application.Icon.Handle;
      uCallbackMessage := WM_USER+101;
      StrCopy(szTip, PChar(Caption));
    end;
    Shell_NotifyIcon(NIM_Add, @FIconData);
  end;
end;

procedure TForm1.SelfIcon(var Message: TMessage);
var
  pt: TPoint;
begin
  case Message.LParam of
    WM_RBUTTONUP:
    begin
      if not Visible then
      begin
        SetForegroundWindow(Handle);
        GetCursorPos(pt);
        PopupMenu1.Popup(pt.x, pt.y);
      end else
        SetForegroundWindow(Handle);
    end;
    WM_LBUTTONDBLCLK:
      if Visible then
        SetForegroundWindow(Handle) else
          Show;
  end;
end;

procedure TForm1.WndProc(var Message: TMessage);
begin
  if Message.Msg = FTaskMessage then
  begin
    AddIcon;
    Refresh;
  end;
  inherited WndProc(Message);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  Ini:TIniFile;
begin
  if chkStart.Checked then
    chkStart.Checked:=false;
  if not NT351 then
    Shell_NotifyIcon(NIM_DELETE, @FIconData);
  Ini:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'option.ini');
  ini.WriteString('option','Password',edtPwd.Text);
  ini.WriteBool('option','FileTransfer',chkFileTransfer.Checked);
  ini.WriteString('option','Port',edtPort.Text);
  ini.WriteInteger('option','ActionAftterClientDisconnect',rgDisconnect.ItemIndex);
  ini.WriteBool('option','DisableViewerInput',chkdvi.Checked);
  ini.WriteInteger('option','MultiViewerConnections',rgMultiViewer.ItemIndex);
  ini.WriteBool('option','RemoveWallPaperViewers',chkRWV.Checked);
  ini.WriteBool('option','CaptureAlphaBlending',chkCAB.Checked);
  ini.WriteBool('option','DSMPlugin',chkDSM.Checked);
  ini.WriteString('option','DSMPluginUsed',cbDSM.Text);
  ini.WriteBool('option','EnableAlpahBlending',chkEAM.Checked);
  ini.WriteBool('option','EnableBlankMonitor',chkEBM.Checked);
  ini.WriteBool('option','EnableHttpConnect',chkhttp.Checked);
  ini.WriteString('option','HttpPort',edtHttp.Text);
  ini.WriteBool('option','RequireMSLogon',chkMslogon.Checked);
  ini.WriteString('option','ServerScale',edtServerScale.Text);
  ini.WriteBool('option','PollFullScreen',chkFullScreen.Checked);
  ini.Free;
end;

procedure TForm1.FormHide(Sender: TObject);
begin
  mvCanClose:=true;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  mvCanClose:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form3.Edit1.Text:='';
  Form3.Edit2.Text:='';
  if Form3.ShowModal=mrOK then
  begin
    VNCServer1.AddClient(Form3.Edit1.Text,5500,Form3.Edit2.Text<>'',Form3.Edit2.Text);
  end;
end;

procedure TForm1.chkFullScreenClick(Sender: TObject);
begin
  VNCServer1.PollFullScreen:=chkFullScreen.Checked;
end;

procedure TForm1.chkMslogonClick(Sender: TObject);
begin
  VNCServer1.RequireMSLogon:=chkMslogon.Checked;
end;

end.
