program VNCDemo;

uses
  SvcMgr,
  SysUtils,
  Windows,
  WinSvc,
  forms,
  Unit1 in 'Unit1.pas' {Form1},
  Unit2 in 'Unit2.pas' {Form2},
  Chat_U in 'Chat_U.pas' {Chat_F},
  Service_U in 'Service_U.pas' {Service_F: TService},
  Unit3 in 'Unit3.pas' {Form3};

{$R *.res}

function Installing: Boolean;
begin
  Result := FindCmdLineSwitch('INSTALL',['-','\','/'], True) or
            FindCmdLineSwitch('UNINSTALL',['-','\','/'], True);
end;

function StartService: Boolean;
var
  Mgr, Svc: Integer;
  UserName, ServiceStartName: string;
  Config: Pointer;
  Size: DWord;
begin
  Result := False;
  Mgr := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
  if Mgr <> 0 then
  begin
    Svc := OpenService(Mgr, 'Service_F', SERVICE_ALL_ACCESS);
    Result := Svc <> 0;
    if Result then
    begin
      QueryServiceConfig(Svc, nil, 0, Size);
      Config := AllocMem(Size);
      try
        QueryServiceConfig(Svc, Config, Size, Size);
        ServiceStartName := PQueryServiceConfig(Config)^.lpServiceStartName;
        if CompareText(ServiceStartName, 'LocalSystem') = 0 then
          ServiceStartName := 'SYSTEM';
      finally
        Dispose(Config);
      end;
      CloseServiceHandle(Svc);
    end;
    CloseServiceHandle(Mgr);
  end;
  if Result then
  begin
    Size := 256;
    SetLength(UserName, Size);
    GetUserName(PChar(UserName), Size);
    SetLength(UserName, StrLen(PChar(UserName)));
    Result := CompareText(UserName, ServiceStartName) = 0;
  end;
end;


begin
  if not Installing then
  begin
    CreateMutex(nil, True, 'VNC Server Component Demo');
    if GetLastError = ERROR_ALREADY_EXISTS then
      Halt;
  end;
  if Installing or StartService then
  begin
//    if not SvcMgr.Application. or SvcMgr.Application.Installing then
    begin
      SvcMgr.Application.Initialize;
    end;
    SvcMgr.Application.Title := 'VNC Server Component Demo';
    SvcMgr.Application.CreateForm(TService_F, Service_F);
    SvcMgr.Application.Run;
  end
  else
  begin
    forms.Application.Initialize;
    Forms.Application.Title := 'VNC Server Component Demo';
    Forms.Application.CreateForm(TForm1, Form1);
    Forms.Application.CreateForm(TForm2, Form2);
    Forms.Application.CreateForm(TForm3, Form3);
    Forms.Application.Run;
  end;
end.
