{*******************************************************************************
  : dmzn dmzn@163.com 2005.7
  : ṩļѹ/ѹ

  :
  &.2006-02-06
  TZnZipCreate,Destroy,ѹ߳,Ҫ˳
  ʱԴ޷ͷŵ.
  TZipThread޸DoProcess,DoEnd,жFOwnerǷDestrying״̬,
  ڴд.

  : ԪԴ,/ҵʹ,뱣˴˵.
  ԱԪ˺޸,ʼ֪ͨ,лл!
*******************************************************************************}
unit ZipUnit;

interface

uses
  SysUtils, Classes, ComCtrls, ZlibEx;

type
  TZnZip = class;

  TZipThread = class(TThread)
  private
   { Private declarations }
   FOwner    : TZnZip;
   FZip      : boolean;
   FNormal   : boolean;
   
   FLeft     : integer;
   FHasDone  : integer;
   FZipRate  : Single;
  protected
   { protected declarations }
   procedure DoBegin;
   procedure DoProcess;
   procedure DoEnd;

   procedure Execute; override;
   procedure ZipFile(const nSource,nDest: string);
   procedure UnZipFile(const nSource,nDest: string);
  public
   { public declarations }
   constructor Create(AOwner: TZnZip; IsZip: boolean);
  end;

  TOnBegin = procedure (const nMax: integer) of object;
  TOnProcess = procedure (const nHasDone: integer) of object;
  TOnEnd = procedure (const nNormal: boolean; nZipRate: Single) of object;

  TZnZip = class(TComponent)
  private
   { Private declarations }
   FSource	 : string;
   FDest		 : string;
   FBusy     : boolean;
   FThread   : TZipThread;
   FZipLevel : TZCompressionLevel;

   FOnBegin  : TOnBegin;
   FOnProc   : TOnProcess;
   FOnEnd    : TOnEnd;
  public
   { public declarations }
   constructor Create(AOwner: TComponent);override;
   destructor Destroy;override;

   procedure ZipFile;
   procedure UnZipFile;
   procedure StopZnZip;
  published
   { published declarations }
   property Busy: boolean read FBusy;
   property SourceFile: string read FSource write FSource;
   property DestFile: string read FDest write FDest;
   property OnBegin: TOnBegin read FOnBegin write FOnBegin;
   property OnProcess : TOnProcess read FOnProc write FOnProc;
   property OnEnd: TOnEnd read FOnEnd write FOnEnd;
   property ZipLevel: TZCompressionLevel read FZipLevel write FZipLevel;
  end;

procedure Register;

implementation

const
  BufSize = $F000;

procedure Register;
begin
  RegisterComponents('RunSoft', [TZnZip]);
end;

{********************  TZipThread  ****************}
constructor TZipThread.Create(AOwner: TZnZip; IsZip: boolean);
begin
  FOwner := AOwner;
  FZip := IsZip;
  FreeOnTerminate := True;
  inherited Create(False);
end;

procedure TZipThread.DoBegin;
begin
  if Assigned(FOwner.FOnBegin) then FOwner.FOnBegin(FLeft);
end;

procedure TZipThread.DoEnd;
begin
  FOwner.FThread := nil;
  FOwner.FBusy := False;

  with FOwner do
  begin
     if Assigned(FOnEnd) and (not (csDestroying in ComponentState)) then
       if FNormal then
          if FZip then
              FOnEnd(True, FZipRate)
         else FOnEnd(True, 0)
       else FOnEnd(False, 0);
  end;
end;

procedure TZipThread.DoProcess;
begin
  with FOwner do
  if Assigned(FOnProc) and
     (not (csDestroying in ComponentState)) then FOnProc(FHasDone);
end;

procedure TZipThread.Execute;
begin
    FNormal := True;
  try
    if FZip then
       ZipFile(FOwner.FSource, FOwner.FDest)
    else
       UnZipFile(FOwner.FSource, FOwner.FDest);

    Synchronize(DoEnd);
    if Terminated then FreeOnTerminate := False;
  except
    FNormal := False;
    Synchronize(DoEnd);
  end;
end;

//Name: UnZipFile
//Parm: nSource,ѹļ; nDest,Ŀļ
//Desc: ѹnSourceļ,nDest
procedure TZipThread.UnZipFile(const nSource, nDest: string);
var nSStream: TMemoryStream;
	  nDStream: TMemoryStream;
    nBuf: array [0..BufSize] of Byte;
    nZipStream: TZDecompressionStream;
begin
    nSStream := TMemoryStream.Create;
    nDStream := TMemoryStream.Create;
  try
    nSStream.LoadFromFile(nSource);
    nZipStream := TZDecompressionStream.Create(nSStream);
    nZipStream.Seek(0, soFromBeginning);

    FHasDone := 0;
    FLeft := nZipStream.Size;
    Synchronize(DoBegin);

    while not Terminated and (FLeft > 0) do
    begin
       if FLeft > BufSize then
       begin
         nZipStream.Read(nBuf, BufSize);
         nDStream.Write(nBuf, BufSize);
         FHasDone := FHasDone + BufSize;
       end else
       begin
         nZipStream.Read(nBuf, FLeft);
         nDStream.Write(nBuf, FLeft);
         FHasDone := FHasDone + FLeft;
       end;

       Synchronize(DoProcess);
       FLeft := FLeft - BufSize;
    end;

    nZipStream.Free;
    if Terminated then
       FNormal := False else
    begin
      if FileExists(nDest) then DeleteFile(nDest);
      nDStream.SaveToFile(nDest);
    end;
  finally
    nDStream.Free;
    nSStream.Free;
  end;
end;

//Name: ZipFile
//Parm: nSource,ѹļ; nDest,Ŀļ
//Desc: nSourceѹ,浽nDest
procedure TZipThread.ZipFile(const nSource, nDest: string);
var nSStream: TMemoryStream;
	  nDStream: TMemoryStream;
    nZipStream: TZCompressionStream;
    nBuf: array [0..BufSize] of Byte;
begin
    nSStream := TMemoryStream.Create;
    nDStream := TMemoryStream.Create;
    nZipStream := TZCompressionStream.Create(nDStream, FOwner.FZipLevel);
  try
    nSStream.LoadFromFile(nSource);
    nSStream.Seek(0, soFromBeginning);

    FHasDone := 0;
    FLeft := nSStream.Size;
    Synchronize(DoBegin);

    while not Terminated and (FLeft > 0) do
    begin
       if FLeft > BufSize then
       begin
         nSStream.Read(nBuf, BufSize);
         nZipStream.Write(nBuf, BufSize);
         FHasDone := FHasDone + BufSize;
       end else
       begin
         nSStream.Read(nBuf, FLeft);
         nZipStream.Write(nBuf, FLeft);
         FHasDone := FHasDone + FLeft;
       end;

       Synchronize(DoProcess);
       FLeft := FLeft - BufSize;
    end;

    FZipRate := nZipStream.CompressionRate;
    nZipStream.Free;
    
    if Terminated then
       FNormal := False else
    begin
      if FileExists(nDest) then DeleteFile(nDest);
      nDStream.SaveToFile(nDest);
    end;
  finally
    nDStream.Free;
    nSStream.Free;
  end;
end;

{************************** TZnZip **************************} 
constructor TZnZip.Create(AOwner: TComponent);
begin
  FBusy := False;
  FZipLevel := zcDefault;
  inherited Create(AOwner);
end;

destructor TZnZip.Destroy;
begin
  StopZnZip;
  inherited Destroy;
end;

procedure TZnZip.StopZnZip;
begin
  if FBusy and Assigned(FThread) then
  begin
     FThread.Terminate;
     FThread.WaitFor;
     FThread.Free;
  end;
end;

procedure TZnZip.UnZipFile;
begin
  if not Assigned(FThread) and FileExists(FSource) then
  begin
    FBusy := True;
    FThread := TZipThread.Create(Self, False);
  end;
end;

procedure TZnZip.ZipFile;
begin
  if not Assigned(FThread) and FileExists(FSource) then
  begin
    FBusy := True;
    FThread := TZipThread.Create(Self, True);
  end;
end;

end.
