unit blank_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  Tblank_F = class(TForm)
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    procedure wndproc(var msg:TMessage);override;
    procedure EraseBkgnd(ldc:HDC;cl:TColor);
    function DoGetbkGndBitmap():HBITMAP;
  public
    { Public declarations }
    hbmp:HBITMAP;
    wd,ht:Integer;
  end;

var
  blank_F: Tblank_F;

implementation

{$R *.dfm}

procedure Tblank_F.FormShow(Sender: TObject);
begin
  SetWindowLong(handle, GWL_EXSTYLE, GetWindowLong(Handle, GWL_EXSTYLE)  or WS_EX_LAYERED or WS_EX_TRANSPARENT );
  SetLayeredWindowAttributes(handle, RGB(255,255,255), 180, LWA_ALPHA);
      Timer1.Enabled:=true;
end;

procedure Tblank_F.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=false;
end;

procedure Tblank_F.Timer1Timer(Sender: TObject);
begin
  SetWindowPos(Handle,HWND_TOPMOST,0,0,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN),0);
end;

procedure Tblank_F.wndproc(var msg: TMessage);
begin
  case msg.Msg of    //
    WM_ERASEBKGND:
      begin
        EraseBkgnd(msg.WParam,RGB(0,0,0));
        msg.Result:=DWORD(BOOL(true));
      end;
    WM_CTLCOLORSTATIC:
      begin
        SetBkMode(msg.WParam, TRANSPARENT);
        msg.result:=GetStockObject(NULL_BRUSH);
      end;
  else
    inherited wndproc(msg);
  end;    // case
end;

procedure Tblank_F.EraseBkgnd(ldc: HDC;cl:TColor);
var
  bmp:HBITMAP;
  rc:TRECT;
  hdcmem:HDC;
  hbrBKGnd:HBRUSH;
  hbrold:HGDIOBJ;
  hbmold:HGDIOBJ;
begin
  bmp:=DoGetbkGndBitmap;
  if (ldc<>0) and (bmp<>0) then
  begin
    if (GetClipBox(ldc,rc)<>0) and (not IsRectEmpty(rc)) then
    begin
      hdcmem:=CreateCompatibleDC(ldc);
      if hdcmem<>0 then
      begin
        hbrBkGnd:=CreateSolidBrush(cl);
        if hbrbkgnd<>0 then
        begin
          hbrold:=SelectObject(ldc,hbrBKGnd);
          if hbrold<>0 then
          begin
            if PatBlt(ldc,rc.Left,rc.Top,rc.Right-rc.Left,rc.Bottom-rc.Top,PATCOPY) then
            begin
              hbmold:=SelectObject(hdcmem,bmp);
              if hbmold<>0 then
              begin
                StretchBlt(ldc,0,0,rc.Right-rc.Left,rc.Bottom-rc.Top,hdcmem,0,0,wd,ht,SRCCOPY);
                SelectObject(hdcmem,hbmold)
              end;
              SelectObject(ldc,hbrold);
            end;
          end;
          DeleteObject(hbrBKGnd);
        end;
        DeleteDC(hdcmem)
      end;
    end;
  end;
end;

function Tblank_F.DoGetbkGndBitmap:HBITMAP;
var
  h2:BITMAPINFO;
  hxdc:HDC;
begin
  hbmp:=0;
  hbmp:=LoadImage(0,'Background.bmp',IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
  h2.bmiHeader.biSize:=Sizeof(h2);
  h2.bmiHeader.biBitCount:=0;
  hxdc:=CreateDC('DISPLAY',0,0,0);
  GetDIBits(hxdc,hbmp,0,0,nil,h2,DIB_RGB_COLORS);
  wd:=h2.bmiHeader.biWidth;
  ht:=h2.bmiHeader.biHeight;
  DeleteDC(hxdc);
  if hbmp=0 then
    result := HBITMAP(-1)
  else
    result := hbmp;
end;

end.
